package ExemplesJDBC.GererPrets;
/* Classe de contrle pour EnregistrerPrts
 * Scurit par les traitements
 * Interface  l'utilisateur minimaliste
 * NB Vrifie les conditions de prt et le statut de l'exemplaire au niveau du programme client
 */
import java.sql.*;
import javax.swing.JOptionPane;
import java.util.*;

class ControleEnrPretsSecuriteParTraitement {
    public static void main (String args []) throws Exception {

        // Cration d'une Connection avec un authorizationID SQL indpendant du idCommis
        UsineConnection uneUsineConnection = new UsineConnection();
        Connection uneConnection = uneUsineConnection.getConnectionSansAutoCommit(
        "oracle.jdbc.driver.OracleDriver",
        "jdbc:oracle:thin:@localhost:1521:ora817i",
        "clerat", "oracle");
        try{
            // Authentifier le commis au prt (en utilisant la table Utilisateur)
            String idCommis =
            JOptionPane.showInputDialog("Entrez l'identificateur du commis au prt: ");
            CourtierBDUtilisateur unCourtierBDUtilisateur =
            new CourtierBDUtilisateur(uneConnection);
            Utilisateur lUtilisateur =
            unCourtierBDUtilisateur.chercherUtilisateurParIdUtilisateur(idCommis);
            if (!(lUtilisateur instanceof Employ)){
                JOptionPane.showMessageDialog(null,"Pas un employ :"+idCommis);
            }else {
                Employ leCommis = (Employ)lUtilisateur;                
                if (!(leCommis.getCatgorieEmploy().equals("commis"))){
                    JOptionPane.showMessageDialog(null,"Pas un commis au prt:"+idCommis);
                } else {
                    String motDePasse =
                    JOptionPane.showInputDialog("Entrez le mot de passe : ");
                    if (!(leCommis.getMotPasse().equals(motDePasse))){
                        JOptionPane.showMessageDialog(null,"Mot de passe invalide:"+motDePasse);
                    }else{//OK Commis est authentifi
                        // Dmatrialiser l'Utilisateur et ses PrtsEnCours
                        Membre unMembre = null;
                        String idUtilisateur =
                        JOptionPane.showInputDialog("Entrez l'identificateur de l'utilisateur: ");

                        // Cration du courtier et dmatrialisation de l'Utilisateur
                        Utilisateur unUtilisateur =
                        unCourtierBDUtilisateur.chercherUtilisateurParIdUtilisateur(idUtilisateur);

                        //Cration du courtier et dmatrialisation des PrtsEnCours
                        CourtierBDPrtEnCours unCourtierBDPrtEnCours =
                        new CourtierBDPrtEnCours(uneConnection);
                        unCourtierBDPrtEnCours.chercherLesPrtsEnCours(unUtilisateur);
                        JOptionPane.showMessageDialog(null,
                        "Nombre de prts en cours :" + unUtilisateur.getNbPrtsEnCours());

                        // Vrifier si les conditions pralables sont acceptes
                        boolean conditionsAcceptes = false;
                        if (unUtilisateur instanceof Membre){
                            unCourtierBDUtilisateur.chercherVariablesStatiquesDeMembre();
                            unMembre = (Membre)unUtilisateur;
                            if (!unMembre.conditionsPrtAcceptes()){
                                JOptionPane.showMessageDialog(null,
                                "Prt refus\nNb de prts :" + unMembre.getNbPrtsEnCours()+
                                ". Maximum :" + Membre.getNbMaxPrts() +
                                "\nNb de retards :" + unMembre.getNbRetards());
                        } else {conditionsAcceptes = true;}
                    } else {conditionsAcceptes = true;}// Pas de contrainte pour un employ
                        if(conditionsAcceptes){
                            String idExemplaire = JOptionPane.showInputDialog("Entrez l'identificateur de l'exemplaire:");

                            // Vrifier statut de l'exemplaire
                            CourtierBDExemplaire unCourtierBDExemplaire =
                            new CourtierBDExemplaire(uneConnection);
                            Exemplaire unExemplaire =
                            unCourtierBDExemplaire.chercherExemplaireParIdExemplaire(idExemplaire);
                            if (unExemplaire.getStatut().equals("disponible")){

                                // Gnrer la date du jour et l'objet PrtEnCours
                                Calendar maintenant = Calendar.getInstance(); // Calendrier avec date actuelle
                                java.sql.Date dateMaintenant =
                                new java.sql.Date(maintenant.getTime().getTime());
                                PrtEnCours leNouveauPrtEnCours =
                                new PrtEnCours(unUtilisateur,dateMaintenant,unExemplaire);

                                // Matrialiser le PrtEnCours dans la BD
                                unCourtierBDPrtEnCours.insrerPrtEnCours(leNouveauPrtEnCours);

                                JOptionPane.showMessageDialog(null,
                                "Prt de l'exemplaire " + idExemplaire +
                                "  l'utilisateur " + idUtilisateur + " confirm.\nDate:" + dateMaintenant
                                );
                            }else{
                                JOptionPane.showMessageDialog(null,"Exemplaire non disponible:"+idExemplaire);
                            }
                        }
                    }
                }
            }
        }
        catch(Exception lException){
            JOptionPane.showMessageDialog(null,lException.getMessage());
            lException.printStackTrace();
        }
        finally{
            uneConnection.commit();
            uneConnection.close();
            System.exit(0);
        }
    }
}