package ExemplesJDBC.GererPrets;
import java.sql.*;
import java.util.*;

public class CourtierBDPrtEnCours {
    private Connection uneConnection;
   
    // Constructeur pour connexion passe par le crateur
    public CourtierBDPrtEnCours(Connection laConnection){
        this.uneConnection = laConnection;
    }
    
    public void setConnection(Connection laConnection){
        this.uneConnection = laConnection;
    }

    public void chercherLesPrtsEnCoursEtExemplaires(Utilisateur unUtilisateur)
    // Dmatrialiser les PrtEnCours d'un Utilisateur ainsi que les Exemplaires correspondants 
    throws Exception{
       // Verrouiller la table des prts en cours pour srialisabilit 
        // (Oracle mode READ COMMITTED)
        PreparedStatement unEnoncLock = uneConnection.prepareStatement(
            "LOCK TABLE PrtEnCours IN SHARE ROW EXCLUSIVE MODE");
        unEnoncLock.execute();
        unEnoncLock.close();
        PreparedStatement unEnoncSQL = uneConnection.prepareStatement
        ("SELECT datePrt,p.idExemplaire,statut "+
        "FROM PrtEnCours p, Exemplaire e WHERE p.idUtilisateur = ? AND p.idExemplaire = e.idExemplaire" );
        String idUtilisateur = unUtilisateur.getIdUtilisateur();
        unEnoncSQL.setString(1,idUtilisateur);
        ResultSet rsultatSelect = unEnoncSQL.executeQuery();
        Vector lesPrts = new Vector();
        while (rsultatSelect.next ()){
            Exemplaire lExemplaire = 
                new Exemplaire(rsultatSelect.getString(2),rsultatSelect.getString(3));
            PrtEnCours unPrt = new PrtEnCours(unUtilisateur,rsultatSelect.getDate(1),lExemplaire);
            lesPrts.addElement(unPrt);
        }
        unUtilisateur.setLesPrts(lesPrts);
        unEnoncSQL.close();
    }
    public void insrerPrtEnCours (PrtEnCours unPrtEnCours)
    // Matrialise un nouveau PrtEnCours dans la BD
        throws Exception, SQLException {
        PreparedStatement unEnoncSQL = uneConnection.prepareStatement
        ("INSERT INTO PrtEnCours(idExemplaire,idUtilisateur)"+
        "VALUES(?,?)");
        unEnoncSQL.setString(1,unPrtEnCours.getIdExemplaire());
        unEnoncSQL.setString(2,unPrtEnCours.getIdUtilisateur());
        //NB la date est gnre automatiquement par le serveur de BD (default sysdate)
        // et le statut est modifi par un TRIGGER
        int n = unEnoncSQL.executeUpdate();
        unEnoncSQL.close();
        if (n != 1){throw new Exception("Insertion dans PrtEnCours a chou");}
    }
}