package ExemplesJDBC.GererPrets;
import java.util.*;
public class Membre extends Utilisateur {
    private static int nbMaxPrts;
    private static int dureMaxPrt;

    private String tlphoneRsidence;

    public Membre(String idUtilisateur, String motPasse, String nom,
        String prnom, String catgorie, String tlphoneRsidence){
        super(idUtilisateur, motPasse, nom, prnom, catgorie);
        this.tlphoneRsidence = tlphoneRsidence;
    }

    public static int getNbMaxPrts(){return nbMaxPrts;}
    public static int getDureMaxPrt(){return dureMaxPrt;}
    public static void setNbMaxPrts(int leNbMaxPrts){nbMaxPrts = leNbMaxPrts;}
    public static void setDureMaxPrts(int laDureMaxPrt){dureMaxPrt = laDureMaxPrt;}

    public void setTlphoneRsidence(String tlphoneRsidence)
        {this.tlphoneRsidence = tlphoneRsidence;}
    public String getTlphoneRsidence(){return tlphoneRsidence;}
    public int getNbRetards(){
        Enumeration enumerationPrts = lesPrts.elements();
        int nbRetards = 0;
        Calendar maintenant = Calendar.getInstance(); // Calendrier avec date actuelle
        // Soustrait ensuite la dure maximale en jours pour obtenir la date minimale 
        // avant laquelle il y a un retard
        maintenant.add(Calendar.DATE,-dureMaxPrt); 
        java.sql.Date dateMinSansRetard = new java.sql.Date(maintenant.getTime().getTime());
        while (enumerationPrts.hasMoreElements()){
            Prt unPrt = (Prt)enumerationPrts.nextElement();
            if (unPrt instanceof PrtEnCours){
                if (dateMinSansRetard.after(unPrt.getDatePrt())){
                    nbRetards++;
                }
            }
        }
        return nbRetards;
    }
    public boolean conditionsPrtAcceptes(){
        return (this.getNbRetards() == 0 && this.getNbPrtsEnCours() < nbMaxPrts);
    }
}